import java.awt.Color;


public class Priklad4{
	static int sirka = 600;
	static int vyska = 600;
	static int delkaCary;
	
	static int x;
	static int y;
	static DrawingTool dt;
	
	static void caraVlevo() {
		dt.line(x, y, x - 2 * delkaCary, y);
		x = x - 2*delkaCary;
	}
	
	static void caraVpravo() {
		dt.line(x + 2 * delkaCary, y, x, y);
		x = x + 2*delkaCary;
	}
	
	static void caraNahoru() {
		dt.line(x, y - 2 * delkaCary, x, y);
		y = y - 2*delkaCary;
	}
	
	static void caraDolu() {
		dt.line(x, y, x, y + 2 * delkaCary);
		y = y + 2*delkaCary;
	}
	
	static void caraNahoruVlevo() {
		dt.line(x - delkaCary, y - delkaCary, x, y);
		x = x - delkaCary;
		y = y - delkaCary;
	}

	static void caraNahoruVpravo() {
		dt.line(x, y, x + delkaCary, y - delkaCary);
		x = x + delkaCary;
		y = y - delkaCary;
	}
	
	static void caraDoluVlevo() {
		dt.line(x, y, x - delkaCary, y + delkaCary);
		x = x - delkaCary;
		y = y + delkaCary;
	}
	
	static void caraDoluVpravo() {
		dt.line(x, y, x + delkaCary, y + delkaCary);
		x = x + delkaCary;
		y = y + delkaCary;
	}
	
	static void A(int i) {
		if (i==0) return;
		A(i - 1);
		caraDoluVpravo();
		B(i - 1);
		caraVpravo();
		D(i - 1);
		caraNahoruVpravo();
		A(i - 1);
	}
	
	static void B(int i) {
		if (i==0) return;
		B(i - 1);
		caraDoluVlevo();
		C(i - 1);
		caraDolu();
		A(i - 1);
		caraDoluVpravo();
		B(i - 1);
	}
	
	static void C(int i) {
		if (i==0) return;
		C(i - 1);
		caraNahoruVlevo();
		D(i - 1);
		caraVlevo();
		B(i - 1);
		caraDoluVlevo();
		C(i - 1);
	}
	
	static void D(int i) {
		if (i==0) return;
		D(i - 1);
		caraNahoruVpravo();
		A(i - 1);
		caraNahoru();
		C(i - 1);
		caraNahoruVlevo();
		D(i - 1);
	}
	
	
	public static void main(String[] args) {	
		dt = new DrawingTool(sirka, vyska);

		delkaCary = 130;
		x = 2*delkaCary;
		
		for(int i=1;i<6;i++){
			delkaCary=delkaCary/2;

			x = 2*delkaCary;
			y = delkaCary;

			dt.clear();

			A(i);
			caraDoluVpravo();
			B(i);
			caraDoluVlevo();
			C(i);
			caraNahoruVlevo();
			D(i);
			caraNahoruVpravo();
		}
	}
}